﻿Imports System.IO

Public Class Form1
  Dim MainBitmap As New System.Drawing.Bitmap(1200, 800)
  Dim NoOfCells = 1200
  Dim cell(NoOfCells) As UInteger
  Dim TotalRule(6) As Integer
  Dim Colours(7) As Integer
  Dim RuleType As String
  Dim SuppressEvents As Boolean = False
  Dim TickCounter As Integer = 0
  Dim stopw As New Stopwatch
  Dim RND As New Random()
  Dim RuleA As Integer = 0
  Dim RuleB As Integer = 0
  Dim RuleC As Integer = 0


  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    ClearBitmap()
    Button1.Enabled = False
    Button2.Enabled = True
    RadioButton1.Checked = True
    RadioButton4.Checked = True
    RadioButton7.Checked = True
    RuleType = "2 col"
    Colours(0) = Color.White.ToArgb
    Colours(1) = Color.DarkGray.ToArgb
    Colours(2) = Color.Tomato.ToArgb
    Colours(3) = Color.LightSkyBlue.ToArgb
    Colours(4) = Color.LimeGreen.ToArgb
    Colours(5) = Color.Khaki.ToArgb
    Colours(6) = Color.Orchid.ToArgb
    Colours(7) = Color.CornflowerBlue.ToArgb
    Timer1.Interval = 40
    Timer1.Enabled = True
    Timer1.Start()
  End Sub
  Private Sub ClearBitmap()
    Dim g As Graphics = Graphics.FromImage(MainBitmap)
    g.Clear(Color.White)
    g.Dispose()
    PictureBox1.Image = MainBitmap
    InitialCells()
  End Sub
  Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    UpdateCells()
    UpdatePicture(MainBitmap)
    PictureBox1.Invalidate()
  End Sub
  Private Sub InitialCells()
    Select Case True
      Case RadioButton7.Checked
        For i As Integer = 1 To NoOfCells - 1
          cell(i) = 0
        Next
        cell(NoOfCells / 2) = 1
      Case RadioButton8.Checked
        For i As Integer = 1 To NoOfCells - 1
          cell(i) = 0
        Next
        cell(NoOfCells / 2 - 1) = 1 : cell(NoOfCells / 2) = 1
      Case RadioButton9.Checked
        For i As Integer = 1 To NoOfCells - 1
          cell(i) = 0
        Next
        For i As Integer = NoOfCells / 2 - 20 To NoOfCells / 2 + 20
          cell(i) = 1
        Next
      Case RadioButton10.Checked
        For i As Integer = 1 To NoOfCells - 1
          cell(i) = RND.Next(2)
        Next
    End Select
  End Sub
  Private Sub UpdateCells()
    'first shift data up by 3 bits to make room for new data
    For i As Integer = 1 To NoOfCells - 1
      cell(i) = cell(i) << 3
    Next
    Dim n As Integer = 0
    Select Case RuleType
      Case "2 col"
        Colours(1) = Color.DarkGray.ToArgb
        For i As Integer = 1 To NoOfCells - 1
          n = (cell(i - 1) >> 3 And 1) Or (cell(i) >> 2 And 2) Or (cell(i + 1) >> 1 And 4)
          cell(i) = cell(i) Or (RuleA >> n And 1)
        Next
      Case "3 col (tot)"
        Colours(1) = Color.LightGray.ToArgb
        TotalRule(6) = NumericUpDown10.Value
        TotalRule(5) = NumericUpDown9.Value
        TotalRule(4) = NumericUpDown8.Value
        TotalRule(3) = NumericUpDown7.Value
        TotalRule(2) = NumericUpDown6.Value
        TotalRule(1) = NumericUpDown5.Value
        TotalRule(0) = NumericUpDown4.Value
        For i As Integer = 1 To NoOfCells - 1
          n = (cell(i - 1) >> 3 And 7) + (cell(i) >> 3 And 7) + (cell(i + 1) >> 3 And 7)
          cell(i) = cell(i) Or TotalRule(n)
        Next
      Case "3 col (sym)"
        Colours(1) = Color.LightGray.ToArgb
        For i As Integer = 1 To NoOfCells - 1
          n = 9 * (cell(i - 1) >> 3 And 7) + 3 * (cell(i) >> 3 And 7) + (cell(i + 1) >> 3 And 7)
          Select Case n
            Case 26 : cell(i) = cell(i) Or NumericUpDown1.Value ' 222
            Case 23 : cell(i) = cell(i) Or NumericUpDown2.Value ' 212
            Case 20 : cell(i) = cell(i) Or NumericUpDown3.Value ' 202
            Case 16 : cell(i) = cell(i) Or NumericUpDown11.Value ' 121
            Case 13 : cell(i) = cell(i) Or NumericUpDown12.Value ' 111
            Case 10 : cell(i) = cell(i) Or NumericUpDown13.Value ' 101
            Case 6 : cell(i) = cell(i) Or NumericUpDown14.Value ' 020
            Case 3 : cell(i) = cell(i) Or NumericUpDown15.Value ' 010
            Case 0 : cell(i) = cell(i) Or NumericUpDown16.Value ' 000
            Case Else : cell(i) = cell(i) Or 1
          End Select
        Next
      Case "N col (tot)"
        Colours(1) = Color.LightGray.ToArgb
        Dim NC As Integer = NumericUpDown20.Value
        For i As Integer = 1 To NoOfCells - 1
          n = (cell(i - 1) >> 3 And 7) + (cell(i) >> 3 And 7) + (cell(i + 1) >> 3 And 7)
          cell(i) = cell(i) Or (n Mod NC)
        Next
    End Select
  End Sub
  Private Sub UpdatePicture(ByVal bm As Bitmap)
    Dim DAB As New DirectAccessBitmap(bm)
    Dim j As Integer
    Select Case True
      Case RadioButton4.Checked
        DAB.LoadBitmap(4)
        For i As Integer = 1 To NoOfCells
          j = 450 + (i + 3) \ 4
          DAB.Pixel(i) = Colours(cell(j) And 7)
          DAB.Pixel(i + NoOfCells) = Colours(cell(j) And 7)
          DAB.Pixel(i + 2 * NoOfCells) = Colours(cell(j) And 7)
          DAB.Pixel(i + 3 * NoOfCells) = Colours(cell(j) And 7)
        Next
      Case Else
        DAB.LoadBitmap(1)
        For i As Integer = 1 To NoOfCells
          DAB.Pixel(i) = Colours(cell(i) And 7)
        Next
    End Select
    DAB.UnloadBitmap()
  End Sub

  Private Sub Start_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    Timer1.Start()
    Button1.Enabled = False
    Button2.Enabled = True
  End Sub
  Private Sub Stop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
    Timer1.Stop()
    Button1.Enabled = True
    Button2.Enabled = False
  End Sub
  Private Sub Reset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
    InitialCells()
    ClearBitmap()
  End Sub
  Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
  RadioButton1.CheckedChanged, RadioButton2.CheckedChanged, RadioButton3.CheckedChanged, RadioButton11.CheckedChanged
    Select Case True
      Case RadioButton1.Checked
        RuleType = "2 col"
        GroupBox1.Enabled = True
        GroupBox3.Enabled = False
        GroupBox4.Enabled = False
        GroupBox7.Enabled = False
      Case RadioButton2.Checked : RuleType = "3 col (tot)"
        GroupBox1.Enabled = False
        GroupBox3.Enabled = True
        GroupBox4.Enabled = False
        GroupBox7.Enabled = False
      Case RadioButton3.Checked : RuleType = "3 col (sym)"
        GroupBox1.Enabled = False
        GroupBox3.Enabled = False
        GroupBox4.Enabled = True
        GroupBox7.Enabled = False
      Case RadioButton11.Checked : RuleType = "N col (tot)"
        GroupBox1.Enabled = False
        GroupBox3.Enabled = False
        GroupBox4.Enabled = False
        GroupBox7.Enabled = True
    End Select
    ClearBitmap()
  End Sub
  Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
  CheckBox1.CheckedChanged, CheckBox2.CheckedChanged, CheckBox3.CheckedChanged, CheckBox4.CheckedChanged,
  CheckBox5.CheckedChanged, CheckBox6.CheckedChanged, CheckBox7.CheckedChanged, CheckBox8.CheckedChanged
    If SuppressEvents Then Exit Sub
    RuleA = 0
    If CheckBox1.Checked Then RuleA = RuleA Or 128
    If CheckBox2.Checked Then RuleA = RuleA Or 64
    If CheckBox3.Checked Then RuleA = RuleA Or 32
    If CheckBox4.Checked Then RuleA = RuleA Or 16
    If CheckBox5.Checked Then RuleA = RuleA Or 8
    If CheckBox6.Checked Then RuleA = RuleA Or 4
    If CheckBox7.Checked Then RuleA = RuleA Or 2
    If CheckBox8.Checked Then RuleA = RuleA Or 1
    SuppressEvents = True
    NumericUpDown17.Value = RuleA
    SuppressEvents = False
    InitialCells()
  End Sub
  Private Sub NumericUpDown17_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown17.ValueChanged
    If SuppressEvents Then Exit Sub
    SuppressEvents = True
    RuleA = NumericUpDown17.Value
    CheckBox1.Checked = (RuleA And 128) <> 0
    CheckBox2.Checked = (RuleA And 64) <> 0
    CheckBox3.Checked = (RuleA And 32) <> 0
    CheckBox4.Checked = (RuleA And 16) <> 0
    CheckBox5.Checked = (RuleA And 8) <> 0
    CheckBox6.Checked = (RuleA And 4) <> 0
    CheckBox7.Checked = (RuleA And 2) <> 0
    CheckBox8.Checked = (RuleA And 1) <> 0
    SuppressEvents = False
    InitialCells()
  End Sub
  Private Sub NumericUpDown10_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
  NumericUpDown10.ValueChanged, NumericUpDown9.ValueChanged, NumericUpDown8.ValueChanged, NumericUpDown7.ValueChanged,
  NumericUpDown6.ValueChanged, NumericUpDown5.ValueChanged, NumericUpDown4.ValueChanged
    If SuppressEvents Then Exit Sub
    RuleB = NumericUpDown10.Value
    RuleB = 3 * RuleB + NumericUpDown9.Value
    RuleB = 3 * RuleB + NumericUpDown8.Value
    RuleB = 3 * RuleB + NumericUpDown7.Value
    RuleB = 3 * RuleB + NumericUpDown6.Value
    RuleB = 3 * RuleB + NumericUpDown5.Value
    RuleB = 3 * RuleB + NumericUpDown4.Value
    SuppressEvents = True
    NumericUpDown18.Value = RuleB
    SuppressEvents = False
    InitialCells()
  End Sub
  Private Sub NumericUpDown18_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown18.ValueChanged
    If SuppressEvents Then Exit Sub
    SuppressEvents = True
    RuleB = NumericUpDown18.Value
    NumericUpDown4.Value = RuleB Mod 3 : RuleB = RuleB \ 3
    NumericUpDown5.Value = RuleB Mod 3 : RuleB = RuleB \ 3
    NumericUpDown6.Value = RuleB Mod 3 : RuleB = RuleB \ 3
    NumericUpDown7.Value = RuleB Mod 3 : RuleB = RuleB \ 3
    NumericUpDown8.Value = RuleB Mod 3 : RuleB = RuleB \ 3
    NumericUpDown9.Value = RuleB Mod 3 : RuleB = RuleB \ 3
    NumericUpDown10.Value = RuleB Mod 3
    SuppressEvents = False
    InitialCells()
  End Sub
  Private Sub NumericUpDown1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
  NumericUpDown1.ValueChanged, NumericUpDown2.ValueChanged, NumericUpDown3.ValueChanged, NumericUpDown11.ValueChanged,
  NumericUpDown12.ValueChanged, NumericUpDown13.ValueChanged, NumericUpDown14.ValueChanged, NumericUpDown15.ValueChanged,
  NumericUpDown16.ValueChanged
    If SuppressEvents Then Exit Sub
    RuleC = NumericUpDown1.Value
    RuleC = 3 * RuleC + NumericUpDown2.Value
    RuleC = 3 * RuleC + NumericUpDown3.Value
    RuleC = 3 * RuleC + NumericUpDown11.Value
    RuleC = 3 * RuleC + NumericUpDown12.Value
    RuleC = 3 * RuleC + NumericUpDown13.Value
    RuleC = 3 * RuleC + NumericUpDown14.Value
    RuleC = 3 * RuleC + NumericUpDown15.Value
    RuleC = 3 * RuleC + NumericUpDown16.Value
    SuppressEvents = True
    NumericUpDown19.Value = RuleC
    SuppressEvents = False
    InitialCells()
  End Sub
  Private Sub NumericUpDown19_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDown19.ValueChanged
    If SuppressEvents Then Exit Sub
    SuppressEvents = True
    RuleC = NumericUpDown19.Value
    NumericUpDown16.Value = RuleC Mod 3 : RuleC = RuleC \ 3
    NumericUpDown15.Value = RuleC Mod 3 : RuleC = RuleC \ 3
    NumericUpDown14.Value = RuleC Mod 3 : RuleC = RuleC \ 3
    NumericUpDown13.Value = RuleC Mod 3 : RuleC = RuleC \ 3
    NumericUpDown12.Value = RuleC Mod 3 : RuleC = RuleC \ 3
    NumericUpDown11.Value = RuleC Mod 3 : RuleC = RuleC \ 3
    NumericUpDown3.Value = RuleC Mod 3 : RuleC = RuleC \ 3
    NumericUpDown2.Value = RuleC Mod 3 : RuleC = RuleC \ 3
    NumericUpDown1.Value = RuleC Mod 3
    SuppressEvents = False
    InitialCells()
  End Sub
  Private Sub RadioButton4_CheckedChanged(sender As Object, e As EventArgs) Handles RadioButton4.CheckedChanged, RadioButton6.CheckedChanged
    Select Case True
      Case RadioButton4.Checked : Timer1.Interval = 40
      Case RadioButton6.Checked : Timer1.Interval = 10
    End Select
  End Sub

  Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
    Form2.Show()
  End Sub

  Private Sub RadioButton7_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton7.CheckedChanged, RadioButton8.CheckedChanged, RadioButton9.CheckedChanged, RadioButton10.CheckedChanged
    InitialCells()
    UpdatePicture(MainBitmap)
    PictureBox1.Invalidate()
  End Sub

  Private Sub NumericUpDown20_ValueChanged(sender As System.Object, e As System.EventArgs) Handles NumericUpDown20.ValueChanged
    InitialCells()
  End Sub
End Class


